import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'am_monitor_plugin.dart';

abstract class AmMonitorPluginPlatform extends PlatformInterface {
  /// Constructs a AmMonitorPluginPlatform.
  AmMonitorPluginPlatform() : super(token: _token);

  static final Object _token = Object();

  static AmMonitorPluginPlatform _instance = AmMonitorPlugin();

  /// The default instance of [AmMonitorPluginPlatform] to use.
  ///
  /// Defaults to [MethodChannelAmMonitorPlugin].
  static AmMonitorPluginPlatform get instance => _instance;
  
  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [AmMonitorPluginPlatform] when
  /// they register themselves.
  static set instance(AmMonitorPluginPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }
}
